<!------------------------------------------------------------------------------------------------>
<!--  @Article   Making GET and POST requests on Web Pages with C#, ASP+ and the .NET Framework -->
<!--  @Copyright (c) 2000, Gopalan Suresh Raj. All Rights Reserved                              -->
<!--  @Version:  0.01                                                                           -->
<!------------------------------------------------------------------------------------------------>

<%@ Page language="C#"  %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.Text.RegularExpressions" %>
<%@ Assembly Name="System.Net.dll" %>
<%@ Assembly Name="System.Text.RegularExpressions.dll" %>


<html>
  <head>
   <title>
    Making GET and POST requests on Web Pages with C#, ASP+ and the .NET Framework by Gopalan Suresh Raj
   </title>
  </head>
  
  <body>

   <SCRIPT runat="server">

   /*****************************************************
    *   writeToURL is a method that writes the contents of
    *   a specified URL to the web
    *****************************************************/
   void writeToURL (WebRequest request, string data) {
   
    byte [] bytes = null;
    // Get the data that is being posted (or sent) to the server
    bytes = System.Text.Encoding.ASCII.GetBytes (data);
    request.ContentLength = bytes.Length;
    // 1. Get an output stream from the request object
    Stream outputStream = request.GetRequestStream ();
    
    // 2. Post the data out to the stream
    outputStream.Write (bytes, 0, bytes.Length);
    
    // 3. Close the output stream and send the data out to the web server
    outputStream.Close ();
   } // end writeToURL method
   
   /*****************************************************
    *   retrieveFromURL is a method that retrieves the contents of
    *   a specified URL in response to a request
    *****************************************************/
   String retrieveFromURL (WebRequest request) {
    // 1. Get the Web Response Object from the request
    WebResponse response = request.GetResponse();
    // 2. Get the Stream Object from the response
    Stream responseStream = response.GetResponseStream();                
    
    // 3. Create a stream reader and associate it with the stream object
    StreamReader reader = new StreamReader (responseStream);
    
    // 4. read the entire stream 
    return reader.ReadToEnd ();
   }

   /*****************************************************
    *   postToURL is a method that forces a POST
    *   of data to a specified URL
    * 
    *   A HTTP POST is a combination of a write to the Web Server 
    *   and an immediate read from the Web server
    *****************************************************/
   void postToURL (Object sender, EventArgs eventArgs) {

    string value = urlList.SelectedItem.Value;   
    // Create the Web Request Object 
    WebRequest request = WebRequestFactory.Create (value);
    // Specify that you want to POST data
    request.Method = "POST";
    request.ContentType = "application/x-www-form-urlencoded";
    if (value != null) {
     // write out the data to the web server
     writeToURL (request, value);
    }
    else {
     request.ContentLength = 0;
    }
    // read the response from the Web Server
    string htmlContent = retrieveFromURL (request);
    // Display the content on the web page
    htmlDisplayArea.InnerHtml = "";
    if (htmlContent != null) {
     htmlDisplayArea.InnerHtml += htmlContent;
    } // end if statement
   } // end postToURL method

   /*****************************************************
    *   getFromURL is a method that retrieves the contents of
    *   a specified URL in response to a request
    *****************************************************/
   void getFromURL (Object sender, EventArgs eventArgs) {
 
    // 1. Create the Web Request Object          
    WebRequest request = WebRequestFactory.Create (urlEditBox.Text);
    string htmlContent = retrieveFromURL (request);
    
    // 2. Display the content on the web page
    htmlDisplayArea.InnerHtml = "";
    if (htmlContent != null) {
     htmlDisplayArea.InnerHtml += htmlContent;
    } // end if statement
   } // end getURL 
   
   </SCRIPT>
    
   <!----------------------------------------------------
    The Form code is here
   ------------------------------------------------------>
   <center>
   
   <form method="post" action="webforays.aspx" runat="server">
     Please enter a URL :
     <asp:TextBox Rows="1" Cols="80" runat=server ID="urlEditBox">
     </asp:TextBox>
     
     <asp:Button runat=server Text="Submit for HTTP GET" ID="getURL" onClick="getFromURL">
     </asp:button>
     <br>
     
     <br>
     Select a URL to view:  
     <asp:dropdownlist runat=server ID="urlList">
     <asp:listitem>http://www.execpc.com/~gopalan</asp:listitem>
     <asp:listitem>http://www14.brinkster.com/ecommware</asp:listitem>
     <asp:listitem>http://www.msn.com</asp:listitem>
     </asp:dropdownlist>
     
     <asp:Button runat=server Text="Submit for HTTP POST" ID="postURL" onClick="postToURL">
     </asp:button>
     
     <frame runat=server ID="htmlDisplayArea" MaintainState="false"  Wrap="True">
     </frame>
    
    </center>
   
   </form>
    
  </body>
</html>

